routes/web.php
<?php

use App\Http\Controllers\ApplicationsController;
use App\Http\Controllers\BooksController;
use App\Http\Controllers\MainPageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [App\Http\Controllers\CategoriesController::class, 'index'])->name('home');

Route::resource('categories', \App\Http\Controllers\CategoriesController::class)->only(['index', 'show']);

Route::get('main', [MainPageController::class, 'index'])->name('main');

Route::resource('books', BooksController::class)->only(['show']);

Route::resource('books.applications', ApplicationsController::class)->only(['create', 'store']);

Route::get('/users/register', [App\Http\Controllers\UsersController::class,
    'register'])->name('users.register');
Route::post('users', [App\Http\Controllers\UsersController::class, 'store'])
    ->name('users.store');
Route::get('/login', [App\Http\Controllers\SessionsController::class, 'create'])
    ->name('sessions.login');
Route::post('/login', [App\Http\Controllers\SessionsController::class, 'store'])
    ->name('sessions.store');
Route::delete('/logout', [App\Http\Controllers\SessionsController::class, 'destroy'])
    ->name('sessions.delete');

app/Models/Application.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Application extends Model
{
    use HasFactory;

    /**
     * @var string[]
     */
    protected $fillable = ['user_id', 'book_id', 'end_date', 'return_date'];


    /**
     * @return BelongsTo
     */
    public function book(): BelongsTo
    {
        return $this->belongsTo(Book::class);
    }

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/ApplicationsController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ApplicationRequest;
use App\Models\Application;
use App\Models\Book;
use App\Models\Category;
use App\Models\User;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\RedirectResponse;

class ApplicationsController extends Controller
{
    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function create(Book $book)
    {
        $library_card = auth_user()->library_card;
        return view('applications.create', compact('book', 'library_card'));
    }


    /**
     * @param ApplicationRequest $request
     * @param Book $book
     * @param User $user
     * @return RedirectResponse
     */
    public function store(ApplicationRequest $request, Book $book, User $user): RedirectResponse
    {
        if($book->status == 'get') {
            $book->status = 'expected';
        } else {
            $book->status = 'get';
        }
        $return_date = $request->input('return_date');
        $book->return_date = Carbon::parse($return_date)->format('Y-m-d');

        $book->save();

        $application = new Application();
        $application->end_date = $request->input('end_date');
        $application->user_id = session()->get('user_id');
        $application->book_id = $book->id;
        $application->save();

        return redirect()->route('categories.index', ['user->id' => $user->id, 'body_>id' => $book->id])->with('status', "Application successfully filled!");
    }
}

resources/views/applications/create.blade.php
@extends('layouts.base')

@section('content')
    @include('notifications.alerts')

        <div class="col main pt-5 mt-3">
            <h1>Get library book</h1>
            <form enctype="multipart/form-data" method="post" action="{{ route('books.applications.store',
 ['book' => $book])}}">
                @csrf
                <div class="form-group">
                    <label for="title"><b>Library card</b></label>
                    <h3>{{$library_card}}</h3>
                </div>
                <div class="form-group">
                    <label for="book_id"><b>Book</b></label>
                    <option>{{$book->title}}, {{$book->author}}</option>
                </div>

                <div class="form-group">
                        <div>
                            <label for="end_date">Date</label>
                            <input type="date" id="end_date" name="end_date">
                        </div>
                </div>

                <button type="submit" class="btn btn-primary">Apply</button>
            </form>
        </div>

@endsection